"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const component_1 = require("./component");
const tia_extjs_query_1 = require("../tia-extjs-query");
const extjs_utils_1 = require("../../extjs-utils");
const compName = 'Button';
// TODO: задействовать везде idForLog.
/**
 * gT.eC.button.a or gT.eC.button.actions
 */
class ButtonActions extends component_1.ComponentActions {
}
ButtonActions.compName = compName;
exports.ButtonActions = ButtonActions;
/**
 * gT.eC.button.c or gT.eC.button.checks
 */
class ButtonChecks extends component_1.ComponentChecks {
}
ButtonChecks.compName = compName;
exports.ButtonChecks = ButtonChecks;
/**
 * gT.eC.button.g or gT.eC.button.grabs
 */
class ButtonGrabs extends component_1.ComponentGrabs {
    /**
     * Returns info about the button which user can see on the display.
     */
    static async info(tEQ, idForLog) {
        const result = await tia_extjs_query_1.queryAndAction({
            tEQ,
            action: 'return tiaEJ.ctByObj.getCompDispIdProps(cmp);',
            idForLog,
            enableLog: false,
        });
        return extjs_utils_1.getCISRVal(tEQ, compName, idForLog, result);
    }
}
ButtonGrabs.compName = compName;
exports.ButtonGrabs = ButtonGrabs;
/**
 * gT.eC.button.l or gT.eC.button.logs
 */
class ButtonLogs extends component_1.ComponentLogs {
    /**
     * Prints info about the button which user can see on the display.
     */
    static async info(tEQ, idForLog) {
        const str = await ButtonGrabs.info(tEQ, idForLog);
        gIn.logger.logln(str);
    }
}
ButtonLogs.compName = compName;
exports.ButtonLogs = ButtonLogs;
class ButtonAPI {
}
ButtonAPI.a = ButtonActions;
ButtonAPI.actions = ButtonActions;
ButtonAPI.c = ButtonChecks;
ButtonAPI.checks = ButtonChecks;
ButtonAPI.g = ButtonGrabs;
ButtonAPI.grabs = ButtonGrabs;
ButtonAPI.l = ButtonLogs;
ButtonAPI.logs = ButtonLogs;
exports.ButtonAPI = ButtonAPI;
//# sourceMappingURL=button.js.map